package moze_intel.projecte.gameObjs.items.tools;

import net.minecraft.block.material.Material;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.ai.attributes.AttributeModifier;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;

import com.google.common.collect.Multimap;

public class DarkAxe extends PEToolBase {

    public DarkAxe() {
        super("dm_axe", (byte) 2, new String[] {});
        this.setNoRepair();
        this.peToolMaterial = "dm_tools";
        this.pePrimaryToolClass = "axe";
        this.harvestMaterials.add(Material.wood);
        this.harvestMaterials.add(Material.plants);
        this.harvestMaterials.add(Material.vine);
    }

    // Only for RedAxe
    protected DarkAxe(String name, byte numCharges, String[] modeDesc) {
        super(name, numCharges, modeDesc);
    }

    @Override
    public ItemStack onItemRightClick(ItemStack stack, World world, EntityPlayer player) {
        clearOdAOE(world, stack, player, "logWood", 0);
        clearOdAOE(world, stack, player, "treeLeaves", 0);
        return stack;
    }

    @Override
    public Multimap getAttributeModifiers(ItemStack stack) {
        Multimap multimap = super.getAttributeModifiers(stack);
        multimap.put(
            SharedMonsterAttributes.attackDamage.getAttributeUnlocalizedName(),
            new AttributeModifier(field_111210_e, "Tool modifier", this instanceof RedAxe ? 9 : 8, 0));
        return multimap;
    }
}
