package moze_intel.projecte.gameObjs.items.tools;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;
import net.minecraftforge.common.IShearable;

public class DarkShears extends PEToolBase {

    public DarkShears() {
        super("dm_shears", (byte) 2, new String[] {});
        this.setNoRepair();
        this.peToolMaterial = "dm_tools";
        this.pePrimaryToolClass = "shears";
        this.harvestMaterials.add(Material.web);
        this.harvestMaterials.add(Material.cloth);
        this.harvestMaterials.add(Material.plants);
        this.harvestMaterials.add(Material.leaves);
        this.harvestMaterials.add(Material.vine);
    }

    // Only for RedShears
    protected DarkShears(String name, byte numCharges, String[] modeDesc) {
        super(name, numCharges, modeDesc);
    }

    @Override
    public boolean onBlockDestroyed(ItemStack stack, World world, Block block, int x, int y, int z,
        EntityLivingBase ent) {
        if (block.getMaterial() != Material.leaves && block != Blocks.web
            && block != Blocks.tallgrass
            && block != Blocks.vine
            && block != Blocks.tripwire
            && !(block instanceof IShearable)) {
            return super.onBlockDestroyed(stack, world, block, x, y, z, ent);
        } else {
            return true;
        }
    }

    @Override
    public boolean canHarvestBlock(Block block, ItemStack stack) {
        return super.canHarvestBlock(block, stack) || block == Blocks.redstone_wire || block == Blocks.tripwire;
    }

    @Override
    public ItemStack onItemRightClick(ItemStack stack, World world, EntityPlayer player) {
        shearEntityAOE(stack, player, 0);
        return stack;
    }

    @Override
    public boolean onBlockStartBreak(ItemStack stack, int x, int y, int z, EntityPlayer player) {
        shearBlock(stack, x, y, z, player);
        return false;
    }
}
