package moze_intel.projecte.gameObjs.items.tools;

import net.minecraft.block.material.Material;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.ai.attributes.AttributeModifier;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemStack;
import net.minecraft.util.MovingObjectPosition;
import net.minecraft.world.World;

import com.google.common.collect.Multimap;

public class DarkShovel extends PEToolBase {

    public DarkShovel() {
        super("dm_shovel", (byte) 1, new String[] {});
        this.setNoRepair();
        this.peToolMaterial = "dm_tools";
        this.pePrimaryToolClass = "shovel";
        this.harvestMaterials.add(Material.grass);
        this.harvestMaterials.add(Material.ground);
        this.harvestMaterials.add(Material.sand);
        this.harvestMaterials.add(Material.snow);
        this.harvestMaterials.add(Material.clay);
    }

    // Only for RedShovel
    protected DarkShovel(String name, byte numCharges, String[] modeDesc) {
        super(name, numCharges, modeDesc);
    }

    @Override
    public ItemStack onItemRightClick(ItemStack stack, World world, EntityPlayer player) {
        if (world.isRemote) {
            return stack;
        }

        MovingObjectPosition mop = this.getMovingObjectPositionFromPlayer(world, player, false);
        if (mop != null && mop.typeOfHit == MovingObjectPosition.MovingObjectType.BLOCK
            && world.getBlock(mop.blockX, mop.blockY, mop.blockZ) == Blocks.gravel) {
            tryVeinMine(stack, player, mop);
        } else {
            digAOE(stack, world, player, false, 0);
        }
        return stack;
    }

    @Override
    public Multimap getAttributeModifiers(ItemStack stack) {
        Multimap multimap = super.getAttributeModifiers(stack);
        multimap.put(
            SharedMonsterAttributes.attackDamage.getAttributeUnlocalizedName(),
            new AttributeModifier(field_111210_e, "Tool modifier", this instanceof RedShovel ? 6 : 5, 0));
        return multimap;
    }
}
